<?php
namespace Utility\Export;



class PdfTemplate
{

	/**
	 * Filename to use for output
	 * @var string
	 */
	protected $_fileName = null;



	/**
	 * Constructor.
	 * @param \Utility\Service\PdfTemplate $template
	 */
	public function __construct(\Utility\Service\PdfTemplate $template)
	{
		$this->_fileName = str_replace(' ', '-', $template->getTitle()) . '.pdf';
		$this->_htmlData = $template->getHtml();
	}

	/**
	 * Output result.
	 * @todo  add email, filesystem and ftp as potential targets.
	 * @param null|string $target
	 */
	public function output($target = null)
	{
		set_time_limit(90);

		$html2pdf = new \HTML2PDF('P', 'A4', 'en', true, 'UTF-8', array(5, 5, 5, 5));
		$html2pdf->writeHTML($this->_htmlData);
		if (is_null($target))
		{
			#-> Direct output.
			$html2pdf->Output($this->_fileName, 'D');
			exit(0);
		}
		elseif (strpos($target, '@'))
		{
			#-> Send to email.
		}
		elseif (empty($target))
		{
			#-> Return document.
			return $html2pdf->Output($this->_fileName, 'S');
		}
		else
		{
			#-> Write to file.
			$html2pdf->Output($target . $this->_fileName, 'F');
		}
	}


}
