<?php
namespace Utility\Service;

use Zend\ServiceManager\ServiceLocatorAwareInterface;
use Zend\ServiceManager\ServiceLocatorInterface;


class Node implements ServiceLocatorAwareInterface
{
	/**
	 * @var ServiceLocatorInterface
	 */
	protected $services;
	/**
	 * @var \Zend\Config\Config
	 */
	protected $config;


	/**
	 * Initialize new instance.
	 * @return \Utility\Service\Node
	 */
	public function __construct()
	{
		$this->config = new \Zend\Config\Config(include __DIR__ . '/../../../config/service.config.php');
		$this->themeStack = array();
	}

	/**
	 * @see \Zend\ServiceManager\ServiceLocatorAwareInterface::setServiceLocator()
	 */
	public function setServiceLocator(ServiceLocatorInterface $serviceLocator)
	{
		$this->services = $serviceLocator;
	}

	/**
	 * @see \Zend\ServiceManager\ServiceLocatorAwareInterface::getServiceLocator()
	 */
	public function getServiceLocator()
	{
		return $this->services;
	}

	/**
	 * Retrieve service config.
	 * @return \Zend\Config\Config
	 */
	public function getConfig()
	{
		return $this->config;
	}



}